﻿{$codepage utf8}
{$mode objfpc}
Unit Complejos;
Interface
Uses Numeros,sysutils,math;
Type
  TComplejo = class(TNumero)
  private 
    Function ObtCompCad:string;
    Procedure PonCompCad(n:string);
   public
   
    Function ObtCad(dec:integer=0):string;override;
    Function PonCad(n:string):integer;override;	   
   
    Constructor Crear(i:double); //Crea un imaginario puro
    Constructor Crear(r,i:double;dec:integer=0);	
	
    Procedure Adicion(n:TNumero);override;
    Procedure Sustracion(n:TNumero);override;    
	Procedure Multiplicacion(n:TNumero);override;
    Procedure Division(n:TNumero);override;
    Procedure Cuadrado(n:TNumero);override;
    Procedure Cuadrado;override;
    Function modulo:double;override;
    Function argumento:double;override;
    Procedure Potencia(n:integer);override;

    Property CompCad:string read ObtCompCad write PonCompCad;	
  End;

Implementation
	
    Constructor TComplejo.Crear(i:double);
      Begin
        Real:=0;
        Imag:=i;
		decimales:=0
      End;

    Constructor TComplejo.Crear(r,i:double;dec:integer=0);
      Begin
        Real:=r;
        Imag:=i;
		decimales:=dec
      End;  

    Procedure TComplejo.Adicion(n:TNumero);
      Begin
		Real:=Real+n.Real;
		Imag:=Imag+n.Imag
      End;

    Procedure TComplejo.Sustracion(n:TNumero);
      Begin       
		Real:=Real-n.Real;
		Imag:=Imag-n.Imag
      End;
    
	Procedure TComplejo.Multiplicacion(n:TNumero);
      var PR,PI:double;
      Begin    
	   Writeln('Multiplicacion con Complejo');
	   PR:=(Real*n.Real)-(Imag*n.Imag);
       PI:=(Real*n.Imag)+(Imag*n.Real);
       Real:=PR;
       Imag:=PI
      End;

    Procedure TComplejo.Division(n:TNumero);
      var aux:double;
          PR,PI:double;
      Begin	      	   
	   if (n.Real=0) and (n.Imag=0) then raise EDivByZero.Create('Error Division por cero');
       aux:=sqr(n.Real)+sqr(n.Imag);
       PR:=(((Real*n.Real)+(Imag*n.Imag))/aux);
       PI:=(((Imag*n.Real)-(Real*n.Imag))/aux);	   
       Real:=PR;	   
       Imag:=PI;	  	   
      End;

    Procedure TComplejo.Cuadrado(n:TNumero);
     Begin       
	   Real:=n.Real; Imag:=n.Imag;
       Multiplicacion(n)
     End;

    Procedure TComplejo.Cuadrado;
     Begin
       Multiplicacion(self)
     End;

    Function TComplejo.modulo:double;
     Begin
      modulo:=sqrt(sqr(Real)+sqr(Imag));
     End;

    Function TComplejo.argumento:double;
     Begin
      argumento:=arctan2(Imag,Real)
     End;

    Procedure TComplejo.Potencia(n:integer);
     Var rn:double;
         PR:double;
         PI:double;
     Begin
       rn:=modulo ** n;
       PR:=rn*cos(argumento*n);
       PI:=rn*sin(argumento*n);
       Real:=PR;
       Imag:=PI
     End;	
    Function TComplejo.ObtCompCad:string;
	 Begin
	   ObtCompCad:=ObtCad(decimales)
	 End;
	 
	Procedure TComplejo.PonCompCad(n:string);
	 Begin
	   if PonCad(n)<>0 then raise EConvertError.Create('Error datos no validos ingresados');
	 End;

    Function TComplejo.ObtCad(dec:integer=0):string;
      var aux1,aux2,p:string;
      Begin
        p:='';
        Str(Real:0:dec,aux1);
        Str(Imag:0:dec,aux2);
        if Imag>=0 then p:='+';
        ObtCad := aux1 + p +  aux2 + 'i';
      End;

    Function TComplejo.PonCad(n:string):integer;
      Var aux:string;
          p,i,error:integer;
          PR,PI:string;
          encontro:boolean; 
          auxD:double;		  
      Begin
       aux:=n;
       Real:=0;
       Imag:=0;
	   error:=0;	   
	   if (aux[length(aux)]='i') and (Not(aux[length(aux)-1]in['0'..'9'])) then aux:=Copy(aux,1,length(aux)-1)+'1i';	      	   	   
       if aux[length(aux)]='i' then
         Begin
           delete(aux,length(aux),1);
           if aux[length(aux)] in ['0'..'9']
              then Begin
                     i:=length(aux);
                     encontro:=false;
                     p:=0;
                     while (not encontro) and (i>1) do
                      Begin
                       if (aux[i]='+') or (aux[i]='-')
                         then Begin
                               encontro:=true;
                               p:=i
                              end;
                       i:=i-1
                      End;
                     PR:=Copy(aux,1,p-1);
                     delete(aux,1,p-1);
                     PI:=aux;
					 Val(PR,auxD,error);
					 Real:=auxD;
                     Val(PI,auxD,error);					 
					 Imag:=auxD;					 					 
					 if (error<>0) 
					   then Begin
					         Real:=0;
					 	    Imag:=0;
					       End;
                   End;
         End
       else
        Begin
		  Val(aux,auxD,error);
		  Real:=auxD;
        End;
       PonCad:=error
      End;
End.